#!/bin/bash
if [[ ! -f /usr/local/mysql/bin/mariadbd ]]; then
echo "Baza danych nie jest zainstalowana"
exit 1
else
dbuser=$(ls -la "/usr/local/mysql" | awk {'print $3'} | uniq -c | awk 'int($1)>=2' | awk '{print $2}')
dbport=$(ps auxf | grep mariadbd | awk {'print $23'} | awk -F '=' {'print $2'})
dbver1=$(curl https://mariadb.com/kb/en/changes-improvements-in-mariadb-106/ | grep -Eo 'MariaDB 10.6.([0-9])' | head -1 | awk '{print $2}')
dbver2=$(cat /etc/db-version)
if [[ "$dbver1" == "$dbver2" ]]; then
exit 1
else
while [[ $(ps -A | grep mariadbd) ]]; do
killall -15 mariadbd
done
cd /usr/local/ && tar -czvf mysql-server.tar.gz mysql
wget https://mirror.vpsfree.cz/mariadb//mariadb-"$dbver1"/bintar-linux-systemd-x86_64/mariadb-"$dbver1"-linux-systemd-x86_64.tar.gz -O /usr/local/mysql/mariadb.tar.gz
cd /usr/local/mysql/ && tar -xzvf mariadb.tar.gz --strip-components 1
echo "$dbver1" > /etc/db-version
sleep 2
chown -R "$dbuser":"$dbuser" /usr/local/mysql
cd /usr/local/mysql && ./bin/mysqld_safe --basedir=/usr/local/mysql/ --datadir=/usr/local/mysql/data --user="$dbuser" --log-error=/usr/local/mysql/data/mysql.err --pid-file=/usr/local/mysql/mysql.pid --secure-file-priv=/usr/local/mysql/mysql_secure --socket=/usr/local/mysql/thesock --port="$dbport" &
fi
fi
